Structure p3d
  x.f
  y.f
  z.f
EndStructure
Global Dim ic.p3d(12)
Global Dim icr.p3d(12)
Global c.f=#PI/180
Global ax=0
Global ay=0
Global az=0
#r=60

Procedure setxyz()
  
  ic(0)\x=#r
  ic(0)\y=#r
  ic(0)\z=#r
  
  ic(1)\x=-#r
  ic(1)\y=-#r
  ic(1)\z=#r
  
  ic(2)\x=#r
  ic(2)\y=-#r
  ic(2)\z=-#r
  
  ic(3)\x=-#r
  ic(3)\y=#r
  ic(3)\z=-#r

EndProcedure

Procedure rotxyz()
  For i=0 To 3
    x.f=ic(i)\x
    y.f=ic(i)\y
    z.f=ic(i)\z
    ;      rotation around Z-axis :  (rotating the point X,Y,Z  A degrees)
    x1.f = Cos (az*c)*x - Sin (az*c)*y;     Xrotated = Cos (A)*X - Sin (A)*Y
    y1.f = Sin (az*c)*x + Cos (az*c)*y;     Yrotated = Sin (A)*X + Cos (A)*Y
                                      ;     Zrotated = Z
    x=x1
    y=y1
    ;Box(x1+320,y1+240,2,2,$FFFFFF)
    ; 
    ; rotation around X-axis :
    ;     Xrotated = X
    y1 = Cos (ax*c)*y - Sin (ax*c)*z;     Yrotated = Cos (A)*Y - Sin (A)*Z
    z1.f = Sin (ax*c)*y + Cos (ax*c)*z;     Zrotated = Sin (A)*Y + Cos (A)*Z
    y=y1
    z=z1
    ; rotation around Y-axis :
    x1 = Cos (ay*c)*x - Sin (ay*c)*z;     Xrotated = Cos (A)*X - Sin (A)*Z
                                    ;     Yrotated = Y
    z1 = Sin (ay*c)*x + Cos (ay*c)*z;     Zrotated = Sin (A)*X + Cos (A)*Z
    
    icr(i)\x=x1
    icr(i)\y=y1
    icr(i)\z=z1
  Next i
  ax=(ax+2)%360;
  ay=(ay+1)%360
  az=(az+3)%360
  
EndProcedure

If InitSprite() And OpenWindow(0,0,0,640,480,"sierpinsky",#PB_Window_SystemMenu|#PB_Window_ScreenCentered) And OpenWindowedScreen(WindowID(0),0,0,640,480,0,0,0) 
  

  setxyz()
  Repeat
    ev=WindowEvent()
    If GetAsyncKeyState_(#VK_ESCAPE) & $8000
      Break
    EndIf
    rotxyz()
    StartDrawing(ScreenOutput())
    Box(0,0,640,480,0)
    RandomSeed(12345)
    x0.w=0
    y0.w=0
    z0.w=0
    For i=0 To 3000
      t=Random(255)&3
      x0=(x0+icr(t)\x)/2
      y0=(y0+icr(t)\y)/2
      z0=(z0+icr(t)\z)/2
      
   ; Box(x0+320,y0+240,1,1,$FFFFFF)
    Box(x0*2+320,y0*2+240,2,2,$FFFFFF)
    Next i
    ;StartDrawing(ScreenOutput()) 
    StopDrawing() 
    FlipBuffers() 
  Until ev=#PB_Event_CloseWindow 
EndIf


; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 82
; FirstLine = 48
; Folding = -
; Executable = sierp.exe